﻿using System.Web.Mvc;
using LogService;
using Ninject;

namespace MVCApp.Helper
{
    /// <summary>
    /// 异常处理特性 
    /// </summary>
    public class ExceptionHandleAttribute : HandleErrorAttribute
    {
        [Inject]
        public ILogService Logger { get; set; }

        public override void OnException(ExceptionContext filterContext)
        {
            Logger.AppendLog(filterContext.Exception.ToString());//记录日志
        }
    }
}