﻿//using System;
//using System.Threading;
//using NUnit.Framework;
//using Ninject;
//using Ninject.Activation.Caching;
//using NinjectApp.Weapon;

//namespace NinjectApp.Test
//{
//    public class ThreadScopeContext
//    {
//        protected StandardKernel kernel;

//        public ThreadScopeContext()
//        {
//            this.SetUp();
//        }

//        public void SetUp()
//        {
//            var settings = new NinjectSettings { CachePruningInterval = TimeSpan.MaxValue };
//            this.kernel = new StandardKernel(settings);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundWithThreadScope : ThreadScopeContext
//    {
//        [Test]
//        public void FirstActivatedInstanceIsReusedWithinThread()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InThreadScope();

//            IWeapon weapon1 = null;
//            IWeapon weapon2 = null;

//            ThreadStart callback = () =>
//            {
//                weapon1 = kernel.Get<IWeapon>();
//                weapon2 = kernel.Get<IWeapon>();
//            };

//            var thread = new Thread(callback);

//            thread.Start();
//            thread.Join();

//            Assert.IsNotNull(weapon1);
//            Assert.IsNotNull(weapon2);
//            Assert.AreEqual(weapon1, weapon2);
//        }

//        [Test]
//        public void ScopeDoesNotInterfereWithExternalRequests()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InThreadScope();

//            IWeapon weapon1 = kernel.Get<IWeapon>();
//            IWeapon weapon2 = null;

//            ThreadStart callback = () => weapon2 = kernel.Get<IWeapon>();

//            var thread = new Thread(callback);

//            thread.Start();
//            thread.Join();

//            Assert.IsNotNull(weapon1);
//            Assert.IsNotNull(weapon2);
//            Assert.AreEqual(weapon1, weapon2);
//        }

//        [Test]
//        public void InstancesActivatedWithinScopeAreDeactivatedAfterThreadIsGarbageCollectedAndCacheIsPruned()
//        {
//            kernel.Bind<NotifiesWhenDisposed>().ToSelf().InThreadScope();
//            var cache = kernel.Components.Get<ICache>();

//            NotifiesWhenDisposed instance = null;

//            ThreadStart callback = () => instance = kernel.Get<NotifiesWhenDisposed>();

//            var thread = new Thread(callback);

//            thread.Start();
//            thread.Join();

//            thread = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            cache.Prune();

//            Assert.IsNotNull(instance);
//            Assert.IsTrue(instance.IsDisposed);
//        }
//    }
//}
