﻿//using System;
//using Ninject;
//using Ninject.Activation;
//using Ninject.Activation.Caching;
//using NinjectApp.Weapon;
//using NUnit.Framework;

//namespace NinjectApp.Test
//{
//    public class TransientScopeContext
//    {
//        protected StandardKernel kernel;

//        public TransientScopeContext()
//        {
//            this.SetUp();
//        }

//        public void SetUp()
//        {
//            this.kernel = new StandardKernel();
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToInterfaceInTransientScope : TransientScopeContext
//    {
//        [Test]
//        public void NewInstanceIsReturnedForEachRequest()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InTransientScope();

//            var instance1 = kernel.Get<IWeapon>();
//            var instance2 = kernel.Get<IWeapon>();

//            Assert.AreSame(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreGarbageCollectedIfAllExternalReferencesAreDropped()
//        {
//            kernel.Bind<IWeapon>().To<Sword>().InTransientScope();

//            var instance = kernel.Get<IWeapon>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToSelfInTransientScope : TransientScopeContext
//    {
//        [Test]
//        public void NewInstanceIsReturnedForEachRequest()
//        {
//            kernel.Bind<Sword>().ToSelf().InTransientScope();

//            var sword1 = kernel.Get<Sword>();
//            var sword2 = kernel.Get<Sword>();

//            Assert.AreSame(sword1, sword2);
//        }

//        [Test]
//        public void InstancesAreGarbageCollectedIfAllExternalReferencesAreDropped()
//        {
//            kernel.Bind<Sword>().ToSelf().InTransientScope();

//            var instance = kernel.Get<Sword>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);

//            var cache = kernel.Components.Get<ICache>();
//            cache.Prune();

//            Assert.IsTrue(cache.Count == 0);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToProviderInTransientScope : TransientScopeContext
//    {
//        [Test]
//        public void NewInstanceIsReturnedForEachRequest()
//        {
//            kernel.Bind<IWeapon>().ToProvider<SwordProvider>().InTransientScope();

//            var instance1 = kernel.Get<IWeapon>();
//            var instance2 = kernel.Get<IWeapon>();

//            Assert.AreSame(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreGarbageCollectedIfAllExternalReferencesAreDropped()
//        {
//            kernel.Bind<IWeapon>().ToProvider<SwordProvider>().InTransientScope();

//            var instance = kernel.Get<IWeapon>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }
//    }

//    [TestFixture]
//    public class WhenServiceIsBoundToMethodInTransientScope : TransientScopeContext
//    {
//        [Test]
//        public void NewInstanceIsReturnedForEachRequest()
//        {
//            kernel.Bind<IWeapon>().ToMethod(x => new Sword()).InTransientScope();

//            var instance1 = kernel.Get<IWeapon>();
//            var instance2 = kernel.Get<IWeapon>();

//            Assert.AreSame(instance1, instance2);
//        }

//        [Test]
//        public void InstancesAreGarbageCollectedIfAllExternalReferencesAreDropped()
//        {
//            kernel.Bind<IWeapon>().ToMethod(x => new Sword()).InTransientScope();

//            var instance = kernel.Get<IWeapon>();
//            var reference = new WeakReference(instance);

//            instance = null;

//            GC.Collect();
//            GC.WaitForPendingFinalizers();

//            Assert.IsTrue(reference.IsAlive);
//        }
//    }

//    public class SwordProvider : Provider<Sword>
//    {
//        protected override Sword CreateInstance(IContext context)
//        {
//            return new Sword();
//        }
//    }
//}
